"use strict";

exports.__esModule = true;
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _createPropertyClass = require("./createPropertyClass");

var _createPropertyClass2 = _interopRequireDefault(_createPropertyClass);

var _IndexedApi = require("./IndexedApi");

var _IndexedApi2 = _interopRequireDefault(_IndexedApi);

var _IndexedShadow = require("./IndexedShadow");

var _IndexedShadow2 = _interopRequireDefault(_IndexedShadow);

var _IndexedShadowImpl = require("./IndexedShadowImpl");

var _IndexedShadowImpl2 = _interopRequireDefault(_IndexedShadowImpl);

var _MapProperty = require("./MapProperty");

var _MapProperty2 = _interopRequireDefault(_MapProperty);

var _Property2 = require("./Property");

var _Property3 = _interopRequireDefault(_Property2);

var _PropertyFactoryShader = require("./PropertyFactoryShader");

var _PropertyFactoryShader2 = _interopRequireDefault(_PropertyFactoryShader);

var _StateType = require("./StateType");

var _StateType2 = _interopRequireDefault(_StateType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IndexedProperty = function (_Property) {
	_inherits(IndexedProperty, _Property);

	function IndexedProperty(stateType) {
		_classCallCheck(this, IndexedProperty);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(IndexedProperty).call(this, stateType));

		_this._indexed = new _IndexedApi2.default(_this);

		_this.setImplementationClass(_IndexedShadowImpl2.default);
		_this.setShadowClass(_IndexedShadow2.default);
		return _this;
	}

	/*
 	Factory function for creating an IndexedProperty subclass suitable for using with new.
 		Parameters (all are optional):
 		shadowType: one of a pojo or class. This parameter defines the new property
 			shadow. If pojo specified, each property and function is mapped onto a Shadow subclass.
 		specCallback: a callback function that will be passed the StateType spec for additional
 			customization, such as setting autoshadow, initial state, or readonly.
 		initialState: the initial state for the new property. (default is [])
 */


	_createClass(IndexedProperty, null, [{
		key: "createClass",
		value: function createClass() {
			var shadowType = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
			var specCallback = arguments[1];
			var initialState = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];

			return (0, _createPropertyClass2.default)(shadowType, initialState, specCallback, IndexedProperty, _IndexedShadow2.default);
		}
	}]);

	return IndexedProperty;
}(_Property3.default);

exports.default = IndexedProperty;


_StateType2.default.defineType(IndexedProperty, function (spec) {
	spec.initialState([]).elementType(_MapProperty2.default.type).typeName("IndexedProperty");
});