"use strict";

exports.__esModule = true;
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ObjectProperty2 = require("./ObjectProperty");

var _ObjectProperty3 = _interopRequireDefault(_ObjectProperty2);

var _MapShadow = require("./MapShadow");

var _MapShadow2 = _interopRequireDefault(_MapShadow);

var _StateType = require("./StateType");

var _StateType2 = _interopRequireDefault(_StateType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	Exposes a Map interface on a shadow property. The Map API is exposed through the MapShadow class, which uses
	the ObjectProperty methods for implementation.
*/

var MapProperty = function (_ObjectProperty) {
	_inherits(MapProperty, _ObjectProperty);

	function MapProperty() {
		var stateType = arguments.length <= 0 || arguments[0] === undefined ? MapProperty.type : arguments[0];

		_classCallCheck(this, MapProperty);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(MapProperty).call(this, stateType));

		_this.setShadowClass(_MapShadow2.default);
		return _this;
	}

	/*
 	Factory function for creating an MapProperty subclass suitable for using with new.
 		Parameters (all are optional):
 		shadowType - one of a pojo or class. This parameter defines the new property
 			shadow. If pojo specified, each property and function is mapped onto a Shadow subclass.
 		specCallback - a callback function that will be passed the StateType spec for additional
 			customization, such as setting autoshadow, initial state, or readonly.
 		initialState: the initial state for the new property. (default is {})
 */


	_createClass(MapProperty, null, [{
		key: "createClass",
		value: function createClass() {
			var shadowType = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
			var specCallback = arguments[1];
			var initialState = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

			return createPropertyClass(shadowType, initialState, specCallback, MapProperty);
		}
	}]);

	return MapProperty;
}(_ObjectProperty3.default);

exports.default = MapProperty;


_StateType2.default.defineType(MapProperty, function (spec) {
	return spec.initialState({}).typeName("MapProperty");
});